Index: orxonox/trunk/src/lib/physics/fields/field.cc
===================================================================
--- orxonox/trunk/src/lib/physics/fields/field.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/field.cc	(revision 4338)
@@ -0,0 +1,59 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "field.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+Field::Field () 
+{
+   this->setClassName ("Field");
+   this->setMagnitude(1);
+   this->setAttenuation(0);
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+Field::~Field () 
+{
+  // delete what has to be deleted here
+}
+
+
+/**
+   \param magnitude the magnitude of the Field.
+*/
+void Field::setMagnitude(const float& magnitude)
+{
+  this->magnitude = magnitude;
+}
+
+/**
+   \param attenuation The attenuation of the Field (the bigger the smaller the region of influence)
+*/
+void Field::setAttenuation(const float& attenuation)
+{
+  this->attenuation = attenuation;
+}
Index: orxonox/trunk/src/lib/physics/fields/field.h
===================================================================
--- orxonox/trunk/src/lib/physics/fields/field.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/field.h	(revision 4338)
@@ -0,0 +1,60 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+/*! 
+    \file field.h
+    \brief abstract definition of a Physical Field
+
+    This is a totally abstract class, that only enables different Physical Fields to 
+    exist on a common Level.
+*/
+
+#ifndef _FIELD_H
+#define _FIELD_H
+
+#include "p_node.h"
+
+// FORWARD DEFINITION
+
+
+
+//! An abstract class that represents a Force.
+class Field : public PNode 
+{
+ public:
+  Field();
+  virtual ~Field();
+
+  /** 
+      \param dt The time over which to apply the force
+      \param data This is the data given to this force, to calculate the ForceVector
+      \returns The Force Vector
+  */
+  virtual Vector calcForce(float dt, const Vector& data) const = 0;
+
+  void setMagnitude(const float& magnitude);
+  /** \returns The Magnitude of the Field */
+  inline const float& getMagnitude(void) const {return this->magnitude;}
+
+  void setAttenuation(const float& attenuation);
+  /** \returns The Attenuation of the Fiels */
+  inline const float& getAttenuation(void) const {return this->attenuation;}
+
+ private:
+  float magnitude;                //!< The strength of the field
+  float attenuation;              //!< The Attenuation (the bigger the shorter the influenced distance).
+};
+
+#endif /* _FIELD_H */
Index: orxonox/trunk/src/lib/physics/fields/fields.h
===================================================================
--- orxonox/trunk/src/lib/physics/fields/fields.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/fields.h	(revision 4338)
@@ -0,0 +1,40 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+/*! 
+    \file fields.h
+    \brief collection of all Headers of all the different fileds there are in the 
+    PhysicsEngine
+*/
+
+
+#ifndef _FILEDS_H
+#define _FIELDS_H
+
+/* The superclass */
+#include "field.h"
+
+/* subclasses Fields without Position */
+#include "gravity.h"
+
+/* subclasses of field with position */
+#include "point_gravity.h"
+#include "twirl.h"
+
+/* many more fields */
+
+
+
+#endif /* _FIELDS_H */
Index: orxonox/trunk/src/lib/physics/fields/gravity.cc
===================================================================
--- orxonox/trunk/src/lib/physics/fields/gravity.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/gravity.cc	(revision 4338)
@@ -0,0 +1,52 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "gravity.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+Gravity::Gravity () 
+{
+   this->setClassName ("Gravity");
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+Gravity::~Gravity () 
+{
+  // delete what has to be deleted here
+}
+
+/**
+   \brief calculates the Gravity on any point in space
+   \param data The Position of the Point in space to attache gravity to.
+   \returns The force.
+*/
+Vector Gravity::calcForce(float dt, const Vector& data) const
+{
+  return /*(this->getAbsDir().apply(Vector(0,1,0)))*/ Vector(0,-1,0) * this->getMagnitude() * dt;
+}
+
+
Index: orxonox/trunk/src/lib/physics/fields/gravity.h
===================================================================
--- orxonox/trunk/src/lib/physics/fields/gravity.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/gravity.h	(revision 4338)
@@ -0,0 +1,29 @@
+/*! 
+    \file gravity.h
+    \brief Definition of ...
+
+*/
+
+#ifndef _GRAVITY_H
+#define _GRAVITY_H
+
+#include "field.h"
+
+// FORWARD DEFINITION
+
+
+
+//! A class for ...
+class Gravity : public Field {
+
+ public:
+  Gravity();
+  virtual ~Gravity();
+
+  virtual Vector calcForce(float dt, const Vector& data) const;
+
+ private:
+
+};
+
+#endif /* _GRAVITY_H */
Index: orxonox/trunk/src/lib/physics/fields/point_gravity.cc
===================================================================
--- orxonox/trunk/src/lib/physics/fields/point_gravity.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/point_gravity.cc	(revision 4338)
@@ -0,0 +1,52 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "point_gravity.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+PointGravity::PointGravity () 
+{
+   this->setClassName ("PointGravity");
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+PointGravity::~PointGravity () 
+{
+  // delete what has to be deleted here
+}
+
+/**
+   \brief calculates the PointGravity on any point in space
+   \param data The Position of the Point in space to attache PointGravity to.
+   \returns The force.
+*/
+Vector PointGravity::calcForce(float dt, const Vector& data) const
+{
+  return (this->getAbsCoor() - data) * this->getMagnitude() * dt;
+}
+
+
Index: orxonox/trunk/src/lib/physics/fields/point_gravity.h
===================================================================
--- orxonox/trunk/src/lib/physics/fields/point_gravity.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/point_gravity.h	(revision 4338)
@@ -0,0 +1,29 @@
+/*! 
+    \file point_gravity.h
+    \brief Definition of ...
+
+*/
+
+#ifndef _POINT_GRAVITY_H
+#define _POINT_GRAVITY_H
+
+#include "field.h"
+
+// FORWARD DEFINITION
+
+
+
+//! A class for ...
+class PointGravity : public Field {
+
+ public:
+  PointGravity();
+  virtual ~PointGravity();
+
+  virtual Vector calcForce(float dt, const Vector& data) const;
+
+ private:
+
+};
+
+#endif /* _POINT_GRAVITY_H */
Index: orxonox/trunk/src/lib/physics/fields/twirl.cc
===================================================================
--- orxonox/trunk/src/lib/physics/fields/twirl.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/twirl.cc	(revision 4338)
@@ -0,0 +1,53 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "twirl.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+Twirl::Twirl () 
+{
+   this->setClassName ("Twirl");
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+Twirl::~Twirl () 
+{
+  // delete what has to be deleted here
+}
+
+/**
+   \brief calculates the Twirl on any point in space
+   \param data The Position of the Point in space to attache twirl to.
+   \returns The force.
+*/
+Vector Twirl::calcForce(float dt, const Vector& data) const
+{
+  return /*this->getAbsDir()*/ Vector(0,1,0).cross(this->getAbsCoor() - data)
+    * this->getMagnitude() * dt;
+}
+
+
Index: orxonox/trunk/src/lib/physics/fields/twirl.h
===================================================================
--- orxonox/trunk/src/lib/physics/fields/twirl.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/fields/twirl.h	(revision 4338)
@@ -0,0 +1,29 @@
+/*! 
+    \file twirl.h
+    \brief Definition of ...
+
+*/
+
+#ifndef _TWIRL_H
+#define _TWIRL_H
+
+#include "field.h"
+
+// FORWARD DEFINITION
+
+
+
+//! A class for ...
+class Twirl : public Field {
+
+ public:
+  Twirl();
+  virtual ~Twirl();
+
+  virtual Vector calcForce(float dt, const Vector& data) const;
+
+ private:
+
+};
+
+#endif /* _TWIRL_H */
Index: orxonox/trunk/src/lib/physics/i_physics.cc
===================================================================
--- orxonox/trunk/src/lib/physics/i_physics.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/i_physics.cc	(revision 4338)
@@ -0,0 +1,92 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PHYSICS
+
+#include "i_physics.h"
+#include "list.h"
+#include "string.h"
+#include "stdincl.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+*/
+IPhysics::IPhysics () 
+{
+   this->setClassName ("IPhysics");
+   this->mass = 0;
+   this->massChildren = 0;
+   this->forceSum = Vector(0, 0, 0);
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+IPhysics::~IPhysics () 
+{
+  // delete what has to be deleted here
+}
+
+void IPhysics::recalcMass()
+{
+	float massSum = 0;
+	
+	tIterator<PNode>* iterator = this->children->getIterator();
+	PNode* pn = iterator->nextElement();
+	while( pn != NULL) 
+    { 
+    	// todo: find out if children are IPhysics in an efficient way
+    	if (strcmp( pn->getClassName(), "IPhysics")) {
+			massSum += ((IPhysics*)pn)->getTotalMass();
+    	}
+      pn = iterator->nextElement();
+    }
+	delete iterator;
+	
+	if (massSum != this->massChildren ) {
+		this->massChildren = massSum;
+		if (strcmp( parent->getClassName(), "IPhysics"))
+			((IPhysics*)parent)->recalcMass();
+	} else {
+		this->massChildren = massSum;
+	}
+}
+	
+	
+void IPhysics::addForce( Vector force )
+{
+	forceSum += force;
+}
+
+void IPhysics::addForce(Vector force, Vector grip)
+{
+	// add central force
+	forceSum += force;
+	// add momentum
+	// todo: some vector math
+}
+	
+void IPhysics::tick( float dt )
+{
+	Vector acc = forceSum / ( massChildren + mass );
+	// todo: introduce kinematics
+}
Index: orxonox/trunk/src/lib/physics/i_physics.h
===================================================================
--- orxonox/trunk/src/lib/physics/i_physics.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/i_physics.h	(revision 4338)
@@ -0,0 +1,40 @@
+/*! 
+    \file i_physics.h
+    \brief a physics interface simulating a body with a mass
+*/
+
+#ifndef _I_PHYSICS_H
+#define _I_PHYSICS_H
+
+#include "p_node.h"
+
+//! A Physics interface
+/**
+   here can be some longer description of this class
+*/
+class IPhysics : public PNode {
+
+ public:
+  IPhysics();
+  virtual ~IPhysics();
+  
+  inline void setMass( float mass ) { this->mass = mass; };					//!< Set the mass of this node
+  inline float getMass( void ) const { return mass; };						//!< Get the mass of this node
+  inline float getTotalMass( void ) const { return mass + massChildren; };	//!< Get the sum of the masses of this node and all subnodes
+  void addForce( Vector force );									//!< Add a central force on this rigid body
+  void addForce( Vector force, Vector grip );						//!< Add a decentral force on this rigid body
+  void tick( float dt );											//!< Update kinematics, reset force sum
+
+ protected:
+  void recalcMass();		//!< Recalculate the mass of the children
+  float mass;				//!< Mass of this node
+  float massChildren;		//!< Sum of the masses of the children nodes
+  Vector forceSum;			//!< Total central force for this tick
+  Quaternion momentumSum;	//!< Total momentum in this tick
+
+ private:
+	
+
+};
+
+#endif /* _I_PHYSICS_H */
Index: orxonox/trunk/src/lib/physics/physics_connection.cc
===================================================================
--- orxonox/trunk/src/lib/physics/physics_connection.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/physics_connection.cc	(revision 4338)
@@ -0,0 +1,66 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_
+
+#include "physics_connection.h"
+
+#include "physics_engine.h"
+
+using namespace std;
+
+
+
+PhysicsConnection::PhysicsConnection(ParticleSystem* particleSystem, Field* field)
+{
+  this->type = PCON_ParticlesField;
+  this->particleSystem = particleSystem;
+  this->field = field;
+
+  PhysicsEngine::getInstance()->addConnection(this);
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+PhysicsConnection::~PhysicsConnection () 
+{
+  PhysicsEngine::getInstance()->removeConnection(this);
+}
+
+/** 
+    \brief applies the Force to some Object.
+    \param dt The time to apply in Seconds
+*/
+void PhysicsConnection::apply(const float& dt) const
+{
+  switch(this->type)
+    {
+    case PCON_IPhysField:
+      
+      break;
+
+    case PCON_ParticlesField:
+      this->particleSystem->applyField(dt, this->field);
+
+      break;
+      
+    case PCON_IPhysIPhys:
+
+      break;
+    }
+}
Index: orxonox/trunk/src/lib/physics/physics_connection.h
===================================================================
--- orxonox/trunk/src/lib/physics/physics_connection.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/physics_connection.h	(revision 4338)
@@ -0,0 +1,44 @@
+/*! 
+    \file physics_connection.h
+    \brief Definition of The Physical Connection Class.
+*/
+
+#ifndef _PHYSICS_CONNECTION_H 
+#define _PHYSICS_CONNECTION_H
+
+#include "field.h"
+#include "particle_system.h"
+#include "i_physics.h"
+
+//! An enumerator for different ConnectionTypes
+typedef enum PCON_Type { PCON_IPhysIPhys = 0,
+			 PCON_IPhysField = 1,
+			 PCON_ParticlesField = 2 };
+
+
+// Forward Declaration
+
+//! A class that Handles Physical Connection between subjects
+class PhysicsConnection {
+
+ public:
+  PhysicsConnection(IPhysics* partnerOne, IPhysics* partnerTwo);
+  PhysicsConnection(IPhysics* subject, Field* field);
+  PhysicsConnection(ParticleSystem* particleSystem, Field* field);
+
+  virtual ~PhysicsConnection();
+
+  void apply(const float& dt) const;
+
+ private:
+  PCON_Type type;                    //!< What kind of connection this is.
+  
+  IPhysics* subject;                 //!< The main Subject of this Connection.
+  IPhysics* partner2;                //!< The second partner of this Connection.
+  
+  ParticleSystem* particleSystem;    //!< A ParticleSystem in this Connection
+  
+  Field* field;                      //!< The field to connect either subject of ParticleSystem to.
+};
+
+#endif /* _PHYSICS_CONNECTION_H */
Index: orxonox/trunk/src/lib/physics/physics_engine.cc
===================================================================
--- orxonox/trunk/src/lib/physics/physics_engine.cc	(revision 4338)
+++ orxonox/trunk/src/lib/physics/physics_engine.cc	(revision 4338)
@@ -0,0 +1,101 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "physics_engine.h"
+
+#include "list.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+*/
+PhysicsEngine::PhysicsEngine() 
+{
+   this->setClassName ("PhysicsEngine");
+
+   this->connections = new tList<PhysicsConnection>;
+}
+
+/**
+   \brief the singleton reference to this class
+*/
+PhysicsEngine* PhysicsEngine::singletonRef = NULL;
+
+/**
+   \returns a Pointer to this Class
+*/
+PhysicsEngine* PhysicsEngine::getInstance(void)
+{
+  if (!PhysicsEngine::singletonRef)
+    PhysicsEngine::singletonRef = new PhysicsEngine();
+  return PhysicsEngine::singletonRef;
+}
+
+/**
+   \brief standard deconstructor
+
+*/
+PhysicsEngine::~PhysicsEngine () 
+{
+  PhysicsEngine::singletonRef = NULL;
+}
+
+/**
+   \brief adds A Physical Connection to the List of Connections
+   \param connection the Connection to add
+   
+   Usually this is done through the constructor of PhysicshConnections
+*/
+void PhysicsEngine::addConnection(PhysicsConnection* connection)
+{
+  this->connections->add(connection);
+}
+
+/**
+   \brief removes A Physical Connection from the List of Connections
+   \param connection the Connection to remove
+   
+   Usually this is done through the destructor of PhysicsConnections
+*/
+void PhysicsEngine::removeConnection(PhysicsConnection* connection)
+{
+  this->connections->remove(connection);
+}
+
+
+
+
+
+/**
+   \brief Steps through all the Connections and Ticks them
+   \param dt The time Passed in Seconds
+
+   This function brings a flow into the whole animation
+*/
+void PhysicsEngine::tick(float dt)
+{
+  tIterator<PhysicsConnection>* iterator = this->connections->getIterator();
+  PhysicsConnection* enumConn = iterator->nextElement();
+  while (enumConn)
+    {
+      enumConn->apply(dt);
+      enumConn = iterator->nextElement();
+    }
+  delete iterator;
+}
Index: orxonox/trunk/src/lib/physics/physics_engine.h
===================================================================
--- orxonox/trunk/src/lib/physics/physics_engine.h	(revision 4338)
+++ orxonox/trunk/src/lib/physics/physics_engine.h	(revision 4338)
@@ -0,0 +1,41 @@
+/*! 
+    \file physics_engine.h
+    \brief Definition of the ... singleton Class
+    
+*/
+
+#ifndef _PHYSICS_ENGINE_H
+#define _PHYSICS_ENGINE_H
+
+#include "base_object.h"
+#include "physics_connection.h"
+#include "fields.h"
+
+// Forward Declaration
+template<class T> class tList;
+
+
+//! A default singleton class.
+class PhysicsEngine : public BaseObject {
+
+ public:
+  static PhysicsEngine* getInstance(void);
+  virtual ~PhysicsEngine(void);
+
+  void addConnection(PhysicsConnection* connection);
+  void removeConnection(PhysicsConnection* connection);
+
+  void tick(float dt);
+
+ private:
+  PhysicsEngine(void);
+  static PhysicsEngine* singletonRef;
+
+  tList<PhysicsConnection>* connections;
+
+  
+};
+
+
+
+#endif /* _PHYSICS_ENGINE_H */
Index: orxonox/trunk/src/story_entities/world.cc
===================================================================
--- orxonox/trunk/src/story_entities/world.cc	(revision 4329)
+++ orxonox/trunk/src/story_entities/world.cc	(revision 4338)
@@ -45,4 +45,5 @@
 #include "particle_engine.h"
 #include "graphics_engine.h"
+#include "physics_engine.h"
 
 #include "command_node.h"
@@ -279,4 +280,5 @@
 
   AnimationPlayer::getInstance(); // initializes the animationPlayer
+  PhysicsEngine::getInstance();
 
   this->localCamera = new Camera();
@@ -453,15 +455,15 @@
 
 
-
-  ParticleSystem* system = new ParticleSystem(1000, PARTICLE_SPRITE);
-  system->setLifeSpan(.5);
-  system->setConserve(.99);
-  system->setRadius(2, 0, 2, 0);
-
-  ParticleEmitter* emitter = new ParticleEmitter(Vector(-1, 0, 0), M_PI_4, 100, .05);
-  emitter->setParent(this->localPlayer);
-  
-  particleEngine->addConnection(emitter, system);
-
+  /*
+    ParticleSystem* system = new ParticleSystem(1000, PARTICLE_SPRITE);
+    system->setLifeSpan(.5);
+    system->setConserve(.99);
+    system->setRadius(2, 0, 2, 0);
+    
+    ParticleEmitter* emitter = new ParticleEmitter(Vector(-1, 0, 0), M_PI_4, 100, .05);
+    emitter->setParent(this->localPlayer);
+    
+    particleEngine->addConnection(emitter, system);
+  */
   WorldEntity* testEntity = new TestEntity();
   //testEntity->setRelCoor(Vector(570, 10, -15));
Index: orxonox/trunk/src/story_entities/world.h
===================================================================
--- orxonox/trunk/src/story_entities/world.h	(revision 4329)
+++ orxonox/trunk/src/story_entities/world.h	(revision 4338)
@@ -37,4 +37,5 @@
   static WorldInterface* getInstance();
   void init(World* world);
+  inline World* getCurrentWorld(void) {return this->worldReference;}
   tList<WorldEntity>* getEntityList();
 
@@ -93,4 +94,6 @@
   void setPath( const char* name);
 
+  inline Camera* getLocalCamera(void) {return this->localCamera;}
+
  private:
   void constuctorInit(char* name, int worldID);
Index: orxonox/trunk/src/subprojects/Makefile.am
===================================================================
--- orxonox/trunk/src/subprojects/Makefile.am	(revision 4329)
+++ orxonox/trunk/src/subprojects/Makefile.am	(revision 4338)
@@ -1,3 +1,10 @@
 SUBDIRS = importer \
+	  particles \
 	  gui \
 	  testmain
+
+noinst_HEADERS = framework.h
+
+
+EXTRA_DIST = framework.cc
+
Index: orxonox/trunk/src/subprojects/framework.cc
===================================================================
--- orxonox/trunk/src/subprojects/framework.cc	(revision 4338)
+++ orxonox/trunk/src/subprojects/framework.cc	(revision 4338)
@@ -0,0 +1,264 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#include "framework.h"
+
+
+#include "p_node.h"
+#include "null_parent.h"
+#include "state.h"
+#include "debug.h"
+#include "graphics_engine.h"
+#include "light.h"
+#include "resource_manager.h"
+#include "camera.h"
+
+
+int verbose;
+
+void* Framework::mainLoop(void* tmp)
+{
+  Framework* framework = Framework::getInstance();
+  while(!framework->isFinished)
+    {
+      while(gtk_events_pending()) 
+	gtk_main_iteration();
+
+      // keyhandler returns false if sdl gets quit by some event
+      framework->eventHandler();
+
+      // tick the scene
+      float dt = framework->tick();
+
+      NullParent::getInstance()->update(dt);
+
+      // Draw the scene
+      framework->draw(dt);
+
+    }
+}
+
+bool Framework::draw(float dt)
+{
+  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
+  glLoadIdentity(); // Reset the view
+  
+  this->moduleDraw(dt);
+  
+  camera->apply();
+  
+  SDL_GL_SwapBuffers(); // Swap the buffers
+}
+
+
+float Framework::tick()
+{
+  currFrame = SDL_GetTicks();
+  float dt = (float)(currFrame - lastFrame) / 1000.0;
+  lastFrame = currFrame;
+
+  this->moduleTick(dt);
+
+  return dt;
+}
+
+
+bool Framework::eventHandler()
+{
+  // This is the main loop for the entire program and it will run until done==TRUE
+  {
+    // And poll for events
+    SDL_Event event;
+    while(SDL_PollEvent(&event))
+    {
+      moduleEventHandler(&event);
+
+      switch (event.type) {
+      case SDL_MOUSEMOTION:
+	{
+	  Vector view = camera->getTarget()->getAbsCoor() - camera->getAbsCoor();
+	  Vector up = Vector(0, 1, 0);
+	  up = camera->getAbsDir().apply(up);
+	  Vector h = up.cross(view);
+	  Vector v = h.cross(view);
+	  h.normalize();
+	  v.normalize();
+
+	  if (mouseDown[1])
+	    camera->setRelCoor(camera->getRelCoor()+ h * event.motion.xrel *.05 - v * event.motion.yrel * .05);
+	  if (mouseDown[3])
+	    camera->getTarget()->setRelCoor(camera->getTarget()->getRelCoor()+ h * event.motion.xrel *.05 - v * event.motion.yrel * .05);
+	    
+	}
+	break;
+      case SDL_MOUSEBUTTONDOWN:
+	switch (event.button.button)
+	  {
+	  case 4:
+	    PRINTF(4)("MouseWheel up\n");
+	    camera->setRelCoor(camera->getRelCoor() + (camera->getTarget()->getAbsCoor() - camera->getAbsCoor())*.1);
+	    break;
+	  case 5:
+	    PRINTF(4)("MouseWheel down\n");
+	    camera->setRelCoor(camera->getRelCoor() - (camera->getTarget()->getAbsCoor() - camera->getAbsCoor())*.1);
+	    break;
+	  case 1:
+	  case 2:
+	  case 3:
+	    mouseDown[event.button.button] = true;
+	    break;
+	  }
+	    
+	break;
+      case SDL_MOUSEBUTTONUP:
+	switch (event.button.button)
+	  {
+	  case 1:
+	  case 2:
+	  case 3:
+	    mouseDown[event.button.button] = false;
+	    break;
+	  }
+	break;
+      case SDL_VIDEORESIZE:
+	GraphicsEngine::getInstance()->resolutionChanged(&event.resize);
+	break;
+      case SDL_KEYDOWN:
+	switch (event.key.keysym.sym)
+	  {
+	  case SDLK_q:
+	  case SDLK_ESCAPE:
+	    quitGui(NULL, NULL);
+	    break;
+	  case SDLK_a:
+	    camera->setRelCoor(camera->getRelCoor() + (camera->getTarget()->getAbsCoor() - camera->getAbsCoor())*.1);
+	    break;
+	  case SDLK_z:
+	    camera->setRelCoor(camera->getRelCoor() - (camera->getTarget()->getAbsCoor() - camera->getAbsCoor())*.1);
+	    break;
+	  case SDLK_h:
+	    this->printHelp();
+	    break;
+	  }
+	break;
+	    
+        // If a quit event was recieved
+      case SDL_QUIT:
+	// then we're done and we'll end this program
+	quitGui(NULL, NULL);
+	break;
+      default:
+	break;
+      }
+
+    }
+
+    // Get the state of the keyboard keys
+    keys = SDL_GetKeyState(NULL);
+
+    // and check if ESCAPE has been pressed. If so then quit
+    if(keys[SDLK_ESCAPE]) return false;
+  }
+  return true;
+}
+
+void Framework::quit(void)
+{
+  this->isFinished = true;
+}
+
+Framework* Framework::singletonRef = NULL;
+
+Framework* Framework::getInstance(void)
+{
+  if (Framework::singletonRef == NULL)
+    Framework::singletonRef = new Framework();
+  return Framework::singletonRef;
+}
+
+Framework::Framework()
+{
+  this->isFinished = false;
+
+  this->lastFrame = 0;
+  // Create a new OpenGL window with the title "Cone3D Basecode" at
+  // 640x480x32, fullscreen and check for errors along the way
+  GraphicsEngine::getInstance();
+
+  LightManager::getInstance();
+  glEnable(GL_TEXTURE_2D);
+
+  // Build the font from a TGA image font.tga in the data directory
+  // Hide the mouse cursor
+  SDL_ShowCursor(2);
+
+  for (int i = 0; i <MOUSE_BUTTON_COUNT; i++)
+    mouseDown[i] = false;
+
+  ResourceManager::getInstance()->setDataDir(DATA_DIRECTORY);
+ 
+
+  moduleInit();
+
+  camera = new Camera();
+
+  State::getInstance()->setCamera(camera, camera->getTarget());
+
+  camera->setAbsCoor(Vector(10, 10, 0));
+}
+
+Framework::~Framework()
+{
+  delete GraphicsEngine::getInstance();
+
+}
+
+
+
+void Framework::printHelp(void) const
+{
+  PRINT(0)(" Help for the frameWork\n");
+  PRINT(0)("========================\n");
+  PRINT(0)("h - print thisHelp\n");
+
+  this->moduleHelp();
+
+}
+
+int quitGui(GtkWidget* widget, void* data)
+{
+#ifdef HAVE_GTK2
+  while(gtk_events_pending()) gtk_main_iteration();
+  Framework::getInstance()->quit();
+#endif /* HAVE_GTK2 */
+}
+
+
+int main(int argc, char *argv[])
+{
+  verbose = 3;
+  
+  Framework* framework = Framework::getInstance();
+
+  framework->moduleInitGui();
+  //  framework->mainloopGui(NULL);
+
+  framework->mainLoop(NULL);
+
+  delete framework;
+  // Kill the GL & SDL screens
+  // And quit
+  return 0;
+}
Index: orxonox/trunk/src/subprojects/framework.h
===================================================================
--- orxonox/trunk/src/subprojects/framework.h	(revision 4338)
+++ orxonox/trunk/src/subprojects/framework.h	(revision 4338)
@@ -0,0 +1,63 @@
+#ifndef _FRAMEWORK_H
+#define _FRAMEWORK_H
+ 
+#include "vector.h"
+#include "glincl.h"
+#include "SDL_events.h"
+
+#include "gui_gtk.h"
+
+
+#define DATA_DIRECTORY "~/svn/data/"
+#define MOUSE_BUTTON_COUNT 8
+
+class Camera;
+
+class Framework {
+ private:
+  Framework();
+  static Framework* singletonRef;
+  
+  Camera* camera;
+  
+  bool isFinished;
+
+  int movement [4];
+  
+  Uint32 lastFrame;
+  Uint32 currFrame;
+    
+  Uint8* keys;        // This variable will be used in the keyboard routine
+  bool mouseDown[MOUSE_BUTTON_COUNT];
+
+ public:
+  ~Framework(); 
+  
+  static Framework* getInstance(void);
+
+
+  void moduleInit();
+  void moduleInitGui(void);
+  void moduleEventHandler(SDL_Event* event);
+  void moduleTick(float dt);
+  void moduleDraw(float dt);
+  
+  void moduleHelp(void) const;
+
+
+
+  static void* mainLoop(void* tmp);
+  bool draw(float dt);
+  float tick();
+  bool eventHandler();
+  void quit();
+
+  static void* mainloopGui(void* tmp);
+
+  void printHelp(void) const;
+};
+
+int quitGui(GtkWidget* widget, void* data);
+
+
+#endif /* _FRAMEWORK_H */
Index: orxonox/trunk/src/subprojects/importer/Makefile.am
===================================================================
--- orxonox/trunk/src/subprojects/importer/Makefile.am	(revision 4329)
+++ orxonox/trunk/src/subprojects/importer/Makefile.am	(revision 4338)
@@ -48,4 +48,4 @@
 		  $(MAINSRCDIR)/lib/coord/null_parent.cc
 
-noinst_HEADERS = framework.h \
-		 windowHandler.h
+noinst_HEADERS = framework.h
+
